

class CircleTracker {

  float x = 0.0;
  float y = 0.0;
  float x2 = 0.0;
  float y2 = 0.0;
  float num_points = 24;
  float rot_deg_inc = radians(360.0/num_points);
  float cur_angle = 90;
  float radius= 360;
  int cur_value = 0;
  // 0 = left  // 1 = right
  int leftOrRight = 0;
  boolean callClearScreen = false;
  //
  int capCounter = 0;
  int numCaps = 0;
  int capInterval = 0;
  int maxCaps = 1000;

  CircleTracker(float $x, float $y, float $x2, float $y2, float $num_points, float $cur_angle, float $radius, int $leftOrRight) {
    x = $x;
    y = $y;
    x2 = $x2;
    y2 = $y2;
    num_points = $num_points;
    cur_angle = $cur_angle;
    radius = $radius;
    rot_deg_inc = radians(360.0/num_points);
    leftOrRight = $leftOrRight;
  }

  void fillInside(color c) {
    if(callClearScreen) {
      clearScreen();
      callClearScreen = false; 
    }

    ellipseMode(CENTER);
    fill(c);
    noStroke();
    ellipse(x,y,radius*2,radius*2);

  }

  void clearScreen() {
    if(leftOrRight == 1) {
      //saveCap();
      println("CLEARING THE CIRCLE right");
      noStroke();
      fill(30);
      rectMode(CORNER);
      rect(width/2,0,width/2,height);
    } 
    else if (leftOrRight == 0) {
      saveCap();
      println("CLEARING THE CIRCLE left");
      noStroke();
      fill(30);
      rectMode(CORNER);
      rect(0,0,width/2,height);
    }
  }

  //returns a point with the next value on the outside of the circle. 
  Point getNextPoint() { 
    cur_value++;

    if(cur_value >= num_points) {
      //draw a rectangle with the background color over 1/2 of the screen
      callClearScreen = true;
      //reset the current value
      cur_value = 0;
    }  
    //calculate the length of the radius line (from the equation of a line) 
    //Radius =  sqrt(sq(x2-x) + sq(y2-y));
    //calculate the current angle based on the x axis of the circle origin
    cur_angle = atan2(y2-(y), x2-(x));
    //add a little to the angle to rotate the line (needs to be a float value) 
    cur_angle += rot_deg_inc;
    //acount for if we have reached origin line (keep rotating in current direction)
    if(cur_angle > TWO_PI) {
      cur_angle -= TWO_PI;
    }
    //calculate x2 and y2 with the trig functions
    x2 = radius * cos(cur_angle) + x;
    y2 = radius * sin(cur_angle) + y;
    //Put the values in an array 
    //Circle_X_Arr[cur_value] = x2;
    //Circle_Y_Arr[cur_value] = y2;
    //point(x2,y2);
    //draw the line
    //    line(x,y,x2,y2);
    //for testing
    //println("cur angle="+cur_angle);
    //println("radius="+ Radius);
    //println("x2="+x2);
    //println("y2="+y2);
    return new Point(x2,y2);
  }

  String createFilename() {
    return "clocks-" + str(year()) + "-" + str(month()) + "-" + str(day()) + "-" + str(hour()) + "-" + str(minute()) + "-" + str(second()) + ".jpg";
  }

  void saveCap() {
    if (numCaps < maxCaps) {
      capCounter++;
      if (capCounter > capInterval) {
        capCounter = 0;
        numCaps++;
        String fn = createFilename();
        save(fn);
      }
    }
  }

} 





